package xn.huaxue.update;

import android.annotation.SuppressLint;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;
import android.widget.CompoundButton;

import androidx.annotation.Nullable;
import androidx.appcompat.app.AppCompatActivity;

import com.blankj.utilcode.util.AppUtils;
import com.blankj.utilcode.util.LogUtils;
import com.blankj.utilcode.util.NetworkUtils;
import com.blankj.utilcode.util.SPUtils;
import com.blankj.utilcode.util.ToastUtils;

import xn.huaxue.update.constant.AppConstant;
import xn.huaxue.update.databinding.ActivitySettingBinding;

public class SettingActivity extends AppCompatActivity {
    private ActivitySettingBinding binding;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        binding = ActivitySettingBinding.inflate(getLayoutInflater());
        setContentView(binding.getRoot());
    }

    @Override
    protected void onResume() {
        super.onResume();

    }

    @Override
    protected void onPostCreate(@Nullable Bundle savedInstanceState) {
        super.onPostCreate(savedInstanceState);
        binding.varBT.setText("版本:" + AppUtils.getAppVersionName());
        binding.snBT.setText("SN:" + Tool.INSTANCE.getSerialNumber());
        binding.ipBT.setText(NetworkUtils.getIPAddress(true));
        binding.rebootBT.setOnClickListener(v -> Tool.INSTANCE.cmd("reboot"));
        binding.fileBrowserBT.setOnClickListener(v -> Tool.INSTANCE.openFileBrowser());
        binding.settingBT.setOnClickListener(v -> Tool.INSTANCE.openSetting());
        binding.barSwitch.setOnCheckedChangeListener((buttonView, isChecked) -> Tool.INSTANCE.showBar(isChecked));
        binding.httpUriET.setText(Tool.INSTANCE.getBaseUrl().toString());

        // 测试地址输入
        binding.httpUriTestBT.setOnClickListener(v -> binding.httpUriET.setText("http://192.168.1.8/api/"));
        // 西农地址输入
        binding.httpUriXnBT.setOnClickListener(v -> binding.httpUriET.setText("http://172.16.0.65/api/"));
        // 管理员密码
        binding.oldPasswordET.setText(SPUtils.getInstance().getString(AppConstant.ADMIN_PASSWORD, "admin@098&"));
        // 保存
        binding.save.setOnClickListener(v -> save());
    }

    private void save() {
        try {
            Editable httpUriETText = binding.httpUriET.getText();
            if (null == httpUriETText || TextUtils.isEmpty(httpUriETText)) {
                binding.httpUriET.setError("请输入Http服务地址");
                return;
            }
            Editable oldPasswordETText = binding.oldPasswordET.getText();
            if (null == oldPasswordETText || TextUtils.isEmpty(oldPasswordETText)) {
                binding.oldPasswordET.setError("请输入管理员密码");
                return;
            }
            SPUtils.getInstance().put(AppConstant.BASE_URL, httpUriETText.toString());
            SPUtils.getInstance().put(AppConstant.ADMIN_PASSWORD, oldPasswordETText.toString());
            finish();
        } catch (Exception e) {
            ToastUtils.showLong("参数异常无法保存,请核对参数!");
            LogUtils.e(Log.getStackTraceString(e));
        }
    }

    @SuppressLint("MissingSuperCall")
    @Override
    public void onBackPressed() {
    }
}